Page MenuHomePhabricator

Enable people to add a summary within Topic Containers
Open, Needs TriagePublic

Description

This task represents the work of making Topic Containers more "robust" by enabling people to add a summary to them.

User story

  • As someone who is motivated to facilitate a discussion towards a decision or action of some kind, I want to be able to summarize the ideas/points of view/considerations/agreements/etc. that have emerged in the discussion, so that the people participating in it can continue talking with a shared understanding of the discussion's current state.

Open question(s)

  • Is it important that the summary be easy to reference while people are drafting a new comment?
  • What – if any – constraints should bound what amount of content people can add to the "field" this task is asking for?

Reference

Event Timeline

ppelberg updated the task description. (Show Details)

Since wikis may want to format these summaries, potentially also for users who opted out of the usability improvements, it would be great if they could specify a template to use. For example a (default-empty) MediaWiki message could be used to specify a template that takes a single unnamed parameter used for the summaries. If the message is non-empty, DiscussionTools would include that (e.g. if the message contains closed discussion and the user summarizes the section as This is the summary. ~~~~, the final wikitext would be {{closed discussion|1=This is the summary. [[User:Example|Example]] 00:00, 1 January 1970 (UTC)}}), otherwise it would include a fallback wikitext to make the feature usable on small wikis, without any configuration (e.g. <div class="mw-dt-topicsummary mw-notalk">This is the summary. [[User:Example|Example]] 00:00, 1 January 1970 (UTC)</div>, using the mw-notalk class from T295553).

Or if we want to support further customization – e.g. being able to specify a status from a given set of values (resolved, pending, in progress etc.) –, instead of relying on a single parameter, DT could simply open VisualEditor’s template editor and let it handle the different parameters.

While it would seem to make sense to store a preload template (e.g. {{closed discussion|1=$1}}) in the MediaWiki message instead of just a template title, it would make extremely difficult (if possible at all) to recognize the added summary afterwards and make it editable; this is why I proposed to simply store the template title.

ppelberg updated the task description. (Show Details)
ppelberg added a subscriber: DLynch.

(Adding example @DLynch shared offline to task description's ===Reference section)

I would prefer to avoid the configuration/limitation of having a message that points to a template. Just use a specific class (mw-dt-topicsummary in your example) would be sufficient to implement this:

=== Topic name ===
<div class="mw-dt-topicsummary">This thread is about xyz</div>
Comments

Just a class is much more limited than a template, for example

  • It can be styled only using sitewide CSS, and not with TemplateStyles. Sitewide CSS is
    • loaded on all pages, including non-read view, articles, or talk pages without any summaries (which I expect to be the majority, as summaries are rather a nice-to-have than a feature that will be used all the time), and
    • can be edited only interface administrators—the configuration MediaWiki message could be edited by “normal” admins as well—, which may be a bottleneck even on larger wikis (huwiki for example has 25 admins and only three interface admins, of which I’m the only one who has edited in the last two weeks, but even I am not super active).
  • It cannot produce anything but styling. Projects may want to prepend “Summary:” to the text (content CSS property should not be used in this case, as it’s inaccessible), or even link to a guideline about topic summaries. They may want to parse and show the author of the summary in a similar way to Flow (instead of Summary: This thread is about xyz [[User:Example|Example]] 03:08, 21 March 2021 (UTC), displaying Summary by [[User:Example|Example]] (1 year, 17 days ago): This thread is about xyz).
Tacsipacsi renamed this task from Enable people to add a summary within Topic Containers to Enable people to add a summary within Topic Containers.Apr 20 2022, 8:26 AM

It cannot produce anything but styling.

I would expect DT to reformat this, and also to load CSS only on pages that need it. Otherwise this is purely an on-wiki community project.

I thought the main purpose of this task is to provide a way to create and edit the summaries easily, not to provide a specific presentation (although a default presentation should be provided, of course, for small wikis). Simply a customization point doesn’t make it a purely on-wiki community project, because

  • there should be a default behavior, specified in DiscussionTools, not on wiki, and
  • the behavior (affordances to create and edit the summary) should stay in DiscussionTools.